<script type="text/javascript">
  (async function() {
    if (!window.dimPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimPromise = prom;
      /* will be resolved by DimConf script */
    }

    const nodeTemplate = {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim/dicValue:dicValue.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim/dicValue:dicValue.label.node-conf')
      },
      service: {
        property: "serviceLabel",
        label: RED._('node-red-dim/dicValue:dicValue.label.service')
      }
    };

    const nodeLabel = function(node, dflt) {
      var suffix = "";
      if (!node.monitored && !node.scheduled) {
        suffix = " \u00B9"; /* superscript one (¹) */
      }
      else if (node.scheduled) {
        suffix = " \u21BB"; /* clockwise open circle arrow (↻) */
      }

      return (node.name || node.serviceLabel || dflt) + suffix;
    };

    /* -- DIM Value Client -- */
    const dim = await dimPromise.promise;
    dim.utils.genNodeTemplate("dim-value-client", nodeTemplate);

    const dicValueDef = {
      category: 'network',
      color: '#F3B567',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-conf", required: true },
        serviceLabel: { value: "", required: true,
          validate: function(s) {
            if (!s) { return false; }

            const res = s.match(dic.regExp.srvDefFormat);
            if (res) {
              s = s.slice(0, res.index); /* extract service name */
            }
            this.serviceName = s; /* update service name */
            return dic.regExp.srvName.test(s);
          }
        },
        serviceName: { value: "" },
        monitored: { value: false },
        scheduled: { value: false },
        timeout: {
          value: RED._('node-red-dim/dicValue:dicValue.default.timeout') },
        stamped: { value: false }
      },
      icon: 'bridge.svg',
      inputs: 0,
      outputs: 1,
      button: {
        onclick: function() {
          dim.utils.getSingleValue(this);
        },
        enabled: function() {
          return !this.changed;
        }
      },
      oneditprepare: function() {
        const node = this;
        $("#node-input-timeout").typedInput({
          type: "num",
          types: ["num"]
        });

        const timeoutInput = $('#div-node-input-timeout');

        const ddl = dim.utils.initDropDownList();
        if (ddl) {
          const updateDdl = async () => {
            const srvList = await dim.utils.serviceList();

            /* service list filtering */
            let filteredList = [];
            if (Array.isArray(srvList)) {
              srvList.forEach(s => {
                /* filter also on eventual definition of service */
                if (s.type === 'SRV' && (!node._def.serviceDefFilter ||
                  s.definition === node._def.serviceDefFilter)) {
                  filteredList.push(s.name  + ' [ ' + s.definition + ' ]');
                }
              });
            }

            ddl.append(filteredList);
          }
          updateDdl();

          $('#node-input-cnf').one('focus', function() {
            $(this).change(function() {
              ddl.clear();
              updateDdl();
            });
          });
        }

        if (node.scheduled) {
          timeoutInput.show();
        }
        else {
          timeoutInput.hide();
        }

        $('#node-input-scheduled').on("change", function() {
          if ($(this).prop("checked")) {
            timeoutInput.show();
          }
          else {
            timeoutInput.hide();
          }
        });
      },
      label: function() {
        return nodeLabel(this, "DIM Value Client");
      }
    };

    RED.nodes.registerType("dim-value-client", dicValueDef);

    /* -- DIM JSON Client -- */
    dim.utils.genNodeTemplate("dim-json-client", nodeTemplate);

    /* deep clone of dim-value-client node definition */
    dicJsonDef = $.extend(true, {}, dicValueDef);

    /* only services with string definition are required */
    dicJsonDef.serviceDefFilter = 'C';
    dicJsonDef.label = function() {
      return nodeLabel(this, "DIM JSON Client");
    };

    /* copy dim-value-client node's static template */
    $('script[data-template-name="dim-json-client"]').text(
      $('script[data-template-name="dim-value-client"]').text());

    RED.nodes.registerType("dim-json-client", dicJsonDef);
  }());
</script>

<script type="text/html" data-template-name="dim-value-client">
  <div class="form-row">
    <label for="node-input-stamped">
      <span data-i18n="dicValue.label.opt-stamped"></span>
    </label>
    <input type="checkbox" id="node-input-stamped" style="display:inline-block; width:15px; vertical-align:baseline;">
  </div>
  <div class="form-row">
    <label for="node-input-monitored">
      <span data-i18n="dicValue.label.opt-monitored"></span>
    </label>
    <input type="checkbox" id="node-input-monitored" style="display:inline-block; width:15px; vertical-align:baseline;">
    <label for="node-input-scheduled" style="padding-left:50px;">
      <span data-i18n="dicValue.label.opt-scheduled"></span>
    </label>
    <input type="checkbox" id="node-input-scheduled" style="display:inline-block; width:15px; vertical-align:baseline;">
  </div>
  <div class="form-row" id="div-node-input-timeout">
    <label for="node-input-timeout">
      <i class="fa fa-clock-o"></i>
      <span data-i18n="dicValue.label.timeout"></span>
    </label>
    <input type="text" id="node-input-timeout" data-i18n="[placeholder]dicValue.default.timeout" style="width:100px;">
    <label for="node-input-timeout">
      <span data-i18n="dicValue.label.timeout-unit"></span>
    </label>
  </div>
</script>

<script type="text/html" data-template-name="dim-json-client"></script>
